﻿using System.Linq;

using NHibernate.SqlCommand;

using NHBurrow = NHibernate.Burrow;

using LearningNHibernate.Models;

using NUnit.Framework;

namespace LearningNHibernate.Tests
{
    [TestFixture]
    public class TestHarness
    {

        [TestFixtureSetUp]
        public void FixtureSetup()
        {
            HibernatingRhinos.Profiler.Appender.NHibernate.NHibernateProfiler.Initialize();
        }

        [SetUp]
        public void Setup()
        {
            new NHBurrow.BurrowFramework().InitWorkSpace();
        }

        [TearDown]
        public void Teardown()
        {
            new NHBurrow.BurrowFramework().CloseWorkSpace();
        }

        [Test]
        public void HasManyTests()
        {
            var session = new NHBurrow.BurrowFramework().GetSession();

            var esisode = session.CreateCriteria<Episode>()
                .CreateAlias( "Comments", "c", JoinType.LeftOuterJoin )
                .List<Episode>().First();

            var count = esisode.Comments.Count;
        }

        [Test]
        public void ReferencesTests()
        {
            var session = new NHBurrow.BurrowFramework().GetSession();

            var comment = session.CreateCriteria<Comment>()
                .CreateAlias("Episode", "e", JoinType.InnerJoin)
                .List<Comment>().First();

            var name = comment.Episode.Name;
        }

    }
}
