﻿
using FluentNHibernate.Cfg;
using FluentNHibernate.Cfg.Db;

using LearningNHibernate.Models;

using NHibernate.Burrow;
using NHibernate.Burrow.Configuration;
using NHibernate.Cfg;

namespace LearningNHibernate.NHibernate
{
    public class FluentConfigurator : IConfigurator
    {
        public void Config(IPersistenceUnitCfg puCfg, Configuration nhCfg)
        {
            var msSqlConfiguration = MsSqlConfiguration.MsSql2005
                .ConnectionString( c => c.FromConnectionStringWithKey( "DBCConnectionString" ) );

            Fluently.Configure( nhCfg )
                .Database( msSqlConfiguration )
                .Mappings( m => m.FluentMappings.AddFromAssemblyOf<Episode>() )
                .BuildConfiguration();
        }

        public void Config(IBurrowConfig val)
        {
            val.PersistenceUnitCfgs.Add(new PersistenceUnitElement
            {
                Name = "PersistenceUnit1",
                NHConfigFile = null
            });
        }
    }
}