﻿using FluentNHibernate.Mapping;

using LearningNHibernate.Models;

namespace LearningNHibernate.NHibernate.Mapping
{
    public class EpisodeMappings : ClassMap<Episode>
    {
        public EpisodeMappings()
        {
            Table( "Episode" );

            Id( x => x.Id );

            Map( x => x.Name );
            Map( x => x.Description );
            Map( x => x.Number, "EpisodeNumber" );
            Map( x => x.ReleaseDate, "EpisodeDate" );
            Map( x => x.CreatedDate );
            Map( x => x.Enabled );

            HasMany( x => x.Comments )
                .KeyColumn( "EpisodeId" )
                .Fetch.Select()
                .Cascade.AllDeleteOrphan();

        }
    }

    public class CommentMappings : ClassMap<Comment>
    {
        public CommentMappings()
        {
            Table("EpisodeComment");

            Id(x => x.Id);

            Map(x => x.Name);
            Map(x => x.EmailAddress);
            Map(x => x.Url);
            Map(x => x.EpisodeComment, "Comment");
            Map(x => x.DateTime);

            References( x => x.Episode, "EpisodeId" )
                .ForeignKey( "EpisodeId" )
                .Fetch.Select()
                .Cascade.SaveUpdate()
                .LazyLoad();

        }
    }
}